{$H+,StdCall+}
Uses cRegExp,Strings,Windows;
var
 s: String;
 hLib: hInst;
 pregp: Pointer;
 reGetProc: tColorerRegExpProc absolute pregp;
 rx: tColorerRegExpClass;
 X: Longint;
 retest: pRegExp;
 res: Boolean;
 match: tMatches;
begin
 WriteLn(#13#10'RegExp test'#13#10'Uses Colorer library'#13#10);
 if not GetLibraryPath(s,rRegExp) then
  begin
   WriteLn('Cannot load regexp library - no registry entry ',rRegExp,' in'#13#10'HKEY_CURRENT_USER\Software\Far\Plugins\Shared\');
   halt;
  end;
 hLib:=LoadLibrary(pChar(s));
 if (hLib=0) then
  begin
   WriteLn('Cannot load regexp library - load failed');
   Halt;
  end;
 pregp:=GetProcAddress(hLib,'GetRegExpProc');
 if (pregp=nil) then Halt;
 rx.size:=SizeOf(rx);

 if (not reGetProc(@rx)) then halt;

 retest:=rx.reCreate;

 repeat
  Write(#13#10'regexp: '); ReadLn(s);
  res:=rx.reSetExpr(retest,pChar(s));
  if (not res) then continue;
  Write('exprn: '); ReadLn(s);
  res:=rx.reParse(retest,pChar(s),@match);
  if res then WriteLn('ok') else WriteLn('error');
  Write('match: ');
  for x:=0 to match.CurMatch-1 do
   begin
    Write(x,':','(',match.s[x],',',match.e[x],'), ');
   end;
  WriteLn;
 until (s='');
 rx.reDestroy(retest);
 FreeLibrary(hLib);
end.
